Loading...
Searching...
No Matches
Dune::cpgrid::WellConnections Class Reference

A class calculating and representing all connections of wells. More...

`#include <WellConnections.hpp>`

## Public Types

typedef std::vector< std::set< int > >::const_iterator | const_iterator
| The const iterator type.
typedef const_iterator | iterator
| The iterator type (always const).

## Public Member Functions

| WellConnections (const std::vector< OpmWellType > &wells, const std::unordered_map< std::string, std::set< int > > &possibleFutureConnections, const std::array< int, 3 > &cartesianSize, const std::vector< int > &cartesian_to_compressed)
| Constructor.
| WellConnections (const std::vector< OpmWellType > &wells, const std::unordered_map< std::string, std::set< int > > &possibleFutureConnections, const Dune::CpGrid &cpGrid)
| Constructor.
void | init (const std::vector< OpmWellType > &wells, const std::unordered_map< std::string, std::set< int > > &possibleFutureConnections, const std::array< int, 3 > &cartesianSize, const std::vector< int > &cartesian_to_compressed)
| Initialze the data of the container.
const std::set< int > & | operator[] (std::size_t i) const
| Access all connections of a well.
const_iterator | begin () const
| Get a begin iterator.
const_iterator | end () const
| Get the end iterator.
std::size_t | size () const
| \breif Get the number of wells

## Detailed Description

A class calculating and representing all connections of wells.

Wells are identified by their position as exported by the wells method of the eclipse parser. For each well the container stores at the well index all indices of cells that the well perforates.

## Constructor & Destructor Documentation

## WellConnections() [1/2]

Dune::cpgrid::WellConnections::WellConnections | ( | const std::vector< OpmWellType > & | wells,
|  | const std::unordered_map< std::string, std::set< int > > & | possibleFutureConnections,
|  | const std::array< int, 3 > & | cartesianSize,
|  | const std::vector< int > & | cartesian_to_compressed )

Constructor.

Parameters

  wells | The eclipse information about the wells
  possibleFutureConnections | Possible future connections of wells that might get added through an ACTIONX. The grid will then be partitioned such that these connections are on the same partition. If NULL, they will be neglected.
  cartesianSize | The logical cartesian size of the grid.
  cartesian_to_compressed | Mapping of cartesian index compressed cell index. The compressed index is used to represent the well conditions.

## WellConnections() [2/2]

Dune::cpgrid::WellConnections::WellConnections | ( | const std::vector< OpmWellType > & | wells,
|  | const std::unordered_map< std::string, std::set< int > > & | possibleFutureConnections,
|  | const Dune::CpGrid & | cpGrid )

Constructor.

Parameters

  wells | The eclipse information about the wells
  possibleFutureConnections | Possible future connections of wells that might get added through an ACTIONX. The grid will then be partitioned such that these connections are on the same partition. If NULL, they will be neglected.
  cpGrid | The corner point grid

## Member Function Documentation

## init()

void Dune::cpgrid::WellConnections::init | ( | const std::vector< OpmWellType > & | wells,
|  | const std::unordered_map< std::string, std::set< int > > & | possibleFutureConnections,
|  | const std::array< int, 3 > & | cartesianSize,
|  | const std::vector< int > & | cartesian_to_compressed )

Initialze the data of the container.

Parameters

  wells | The eclipse information about the wells
  possibleFutureConnections | Possible future connections of wells that might get added through an ACTIONX. The grid will then be partitioned such that these connections are on the same partition. If NULL, they will be neglected.
  cartesianSize | The logical cartesian size of the grid.
  cartesian_to_compressed | Mapping of cartesian index compressed cell index. The compressed index is used to represent the well conditions.

## operator[]()

const std::set< int > & Dune::cpgrid::WellConnections::operator[] | ( | std::size_t | i | ) | const

inline

Access all connections of a well.

Parameters

  i | The index of the well (position of the well in the eclipse schedule.

Returns
  The set of compressed indices of cells perforated by the well.

The documentation for this class was generated from the following files:

- opm/grid/common/WellConnections.hpp
- opm/grid/common/WellConnections.cpp